<?php
/*
Plugin Name: Category Single Product Redirect (EasyToolsWP)
Description: Redirects to the single product page if only one product exists in a category.
Version: 1.0.1
Author: EasyToolsWP
*/

// Hook into the template_redirect action
add_action('template_redirect', 'redirect_single_product_category');

function redirect_single_product_category() {
    // Check if we're on a product category page
    if (is_product_category()) {
        // Get the current category
        $category = get_queried_object();
        
        // Get all products in this category
        $args = array(
            'post_type' => 'product',
            'posts_per_page' => -1,
            'post_status' => 'publish',
            'tax_query' => array(
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'id',
                    'terms' => $category->term_id,
                    'operator' => 'IN',
                ),
            ),
        );

        $products = new WP_Query($args);

        // If there is only one product in the category
        if ($products->found_posts === 1) {
            // Get the single product ID
            $single_product_id = $products->posts[0]->ID;

            // Redirect to the single product page
            wp_redirect(get_permalink($single_product_id));
            exit;
        }
    }
}
